Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# GT2005GetupEngine Class Reference

The GT2005 getup engine. More...

`#include <GT2005GetupEngine.h>`

Inheritance diagram for GT2005GetupEngine:

[legend]
Collaboration diagram for GT2005GetupEngine:

[legend]
List of all members.

## Public Member Functions
| GT2005GetupEngine (const GetupEngineInterfaces &interfaces)
| Constructor.
virtual bool | executeParameterized (JointData &jointData)
| Executes the engine.
## Protected Types
enum | { unknown, leftSideDown, rightSideDown, getupFromUpright, standing, rollRight, rollLeft, numOfStates }
| current state More...
## Protected Attributes
JointDataSequencer | sequencer
| the JointDataSequencer
enum GT2005GetupEngine:: { ... } | state
| current state
enum GT2005GetupEngine:: { ... } | lastState
| current state
JointDataSequence | sequence [numOfStates]
| joint data sequence executed in each state
JointDataSequence | sequenceERS7 [numOfStates]
| joint data sequence executed in each state for ERS 7
unsigned long | stateStartTime
unsigned long | lastGetupTime
int | countTry

## Detailed Description

The GT2005 getup engine.

It executes different JointDataSequences for different body roll angles. Body roll angle is determined by current acceleration sensor values.

Definition at line 33 of file GT2005GetupEngine.h.

## Member Enumeration Documentation

anonymous enum`[protected]`

  | current state Enumeration values:
  unknown |
  leftSideDown |
  rightSideDown |
  getupFromUpright |
  standing |
  rollRight |
  rollLeft |
  numOfStates |
Definition at line 48 of file GT2005GetupEngine.h.

## Constructor & Destructor Documentation

GT2005GetupEngine::GT2005GetupEngine | ( | const GetupEngineInterfaces & | interfaces | ) |

| Constructor. Definition at line 114 of file GT2005GetupEngine.cpp. References countTry, JointDataSequence::entry, getupFromUpright, I, JointDataSequence::interpolate, leftSideDown, JointDataSequence::loop, JointDataSequence::numOfEntries, JointDataSequence::repeats, rightSideDown, sequence, and sequenceERS7.

## Member Function Documentation

bool GT2005GetupEngine::executeParameterized | ( | JointData & | jointData | ) | `[virtual]`

| Executes the engine. Implements GetupEngine. Definition at line 427 of file GT2005GetupEngine.cpp. References BodyPosture::bodyRollCalculatedFromAccelerationSensors, BodyPosture::bodyTiltCalculatedFromAccelerationSensors, countTry, SensorData::data, MotionInfo::executedMotionRequest, SystemCall::getCurrentSystemTime(), getRobotConfiguration(), RobotConfiguration::getRobotDesign(), SystemCall::getTimeSince(), getupFromUpright, gt2005GetupEngineFalldownRollAngle, gt2005GetupEngineFalldownRollAngle7, gt2005GetupEngineFalldownTiltAngle, gt2005GetupEngineFalldownTiltAngle7, gt2005GetupEngineFalldownTiltAngleBack7, gt2005GetupEngineRollOnWallAngle, gt2005GetupEngineRollOnWallAngle7, JointDataSequencer::isRunning(), SensorDataBuffer::lastFrame(), lastGetupTime, lastState, leftSideDown, MotionInfo::motionIsStable, MotionRequest::motionType, MotionInfo::neckHeight, JointDataSequencer::nextSequenceData(), SensorDataBuffer::numOfFrames, rightSideDown, sequence, sequenceERS7, sequencer, JointDataSequencer::start(), and stateStartTime.

Here is the call graph for this function:

## Member Data Documentation

JointDataSequencer GT2005GetupEngine::sequencer`[protected]`

| the JointDataSequencer Definition at line 45 of file GT2005GetupEngine.h. Referenced by executeParameterized().

enum { ... } GT2005GetupEngine::state`[protected]`

| current state

enum { ... } GT2005GetupEngine::lastState`[protected]`

| current state Referenced by executeParameterized().

JointDataSequence GT2005GetupEngine::sequence[numOfStates]`[protected]`

| joint data sequence executed in each state Definition at line 76 of file GT2005GetupEngine.h. Referenced by executeParameterized(), and GT2005GetupEngine().

JointDataSequence GT2005GetupEngine::sequenceERS7[numOfStates]`[protected]`

| joint data sequence executed in each state for ERS 7 Definition at line 79 of file GT2005GetupEngine.h. Referenced by executeParameterized(), and GT2005GetupEngine().

unsigned long GT2005GetupEngine::stateStartTime`[protected]`

| Definition at line 81 of file GT2005GetupEngine.h. Referenced by executeParameterized().

unsigned long GT2005GetupEngine::lastGetupTime`[protected]`

| Definition at line 82 of file GT2005GetupEngine.h. Referenced by executeParameterized().

int GT2005GetupEngine::countTry`[protected]`

| Definition at line 83 of file GT2005GetupEngine.h. Referenced by executeParameterized(), and GT2005GetupEngine().

The documentation for this class was generated from the following files:

- Modules/GetupEngine/GT2005GetupEngine.h
- Modules/GetupEngine/GT2005GetupEngine.cpp